<?php
require_once 'Book.php';
class BookFinder {
    private $client;
    function __construct($client) {
       $this->client = $client;
    }
    function findByIsbn($isbn) {
       $url = "http://booksearchapi/json?isbn={$isbn}";
       $json = json_decode($this->client->get($url), true);
       if($json['result'] === 'success') {
           $data = $json['data'];
           return new Book($isbn, $data['title'], $data['author']);
       } else {
           throw new BookNotFoundException();
       }
    }
}
class BookNotFoundException extends Exception {}
class ApiClient {
    public function get($url) {	// (d1)
        return file_get_contents($url, true);
    }
}
?>
