<?php
require_once 'BookFinder.php';
class BookFinderTest extends PHPUnit_Framework_TestCase {
    public function testFindByIsbn() {
        $apiUrl = 'http://booksearchapi/json?isbn=477415377X';
        $json = '{"result": "success", "data": {"title": "JUnit Book", "author": "Shuji Watanabe" }}';
        $stub = $this->getMock('ApiClient');	// (d1)
        $stub->expects($this->any())
             ->method('get')
             ->with($this->equalTo($apiUrl))
             ->will($this->returnValue($json));	// (d2)
        $sut = new BookFinder($stub);	// (d3)
        $actual = $sut->findByIsbn('477415377X');
        $this->assertEquals('477415377X', $actual->isbn);
        $this->assertEquals('JUnit Book', $actual->title);
        $this->assertEquals('Shuji Watanabe', $actual->author);
   }

    /** (d4)
     * @expectedException BookNotFoundException
     */
    public function testFindByIsbn_Error() {
        $apiUrl = 'http://booksearchapi/json?isbn=000';
        $json = '{"result": "not_found"}';	// (d5)
        $stub = $this->getMock('ApiClient');
        $stub->expects($this->any())
             ->method('get')
             ->with($this->equalTo($apiUrl))
             ->will($this->returnValue($json));
        $sut = new BookFinder($stub);
        $sut->findByIsbn('000');
   }
}
?>